## xrt 202520.2.20.172

=== CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022 Xilinx, Inc. All rights reserved.
# Copyright (C) 2025 Advanced Micro Devices, Inc. All rights reserved.
cmake_minimum_required(VERSION 3.5...4.0)

message("-- CMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}")

# Enable testing for this directory and below.  This command should be
# in the source directory root because ctest expects to find a test
# file in the build directory root.
enable_testing()

add_subdirectory(src)

=== tests/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2022 Xilinx, Inc. All rights reserved.
# Copyright (C) 2024 Advanced Micro Devices, Inc. All rights reserved.
#

CMAKE_MINIMUM_REQUIRED(VERSION 3.5.0)
PROJECT(TESTS)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED OFF)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

add_subdirectory(unit_test)
add_subdirectory(xrt)

if (XRT_ENABLE_HIP)
  add_subdirectory(hip)
endif()

=== build/xocl_petalinux_compile/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
#
PROJECT(XRT)
CMAKE_MINIMUM_REQUIRED(VERSION 3.5.0)

SET(PROJECT_DESCRIPTION "https://github.com/Xilinx/XRT")


set (XRT_SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../src")

set(XRT_VERSION_STRING "cross_compile")
set (XRT_INSTALL_DIR           "${CMAKE_BINARY_DIR}")
set (XRT_INSTALL_INCLUDE_DIR   "${XRT_INSTALL_DIR}/include")
set(XRT_NATIVE_BUILD "no")


set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${XRT_SRC_DIR}/CMake/")
set(XRT_DKMS_DRIVER_SRC_BASE_DIR "${XRT_SRC_DIR}/runtime_src/core")
set(XRT_DKMS_INSTALL_DIR "${CMAKE_BINARY_DIR}/../driver_code")
set(CMAKE_SOURCE_DIR "${XRT_SRC_DIR}")

include(${XRT_SRC_DIR}/CMake/version.cmake)
include(${XRT_SRC_DIR}/CMake/dkms.cmake)

#install version.h
install(FILES ${XRT_INSTALL_INCLUDE_DIR}/version.h DESTINATION ${XRT_DKMS_INSTALL_DIR}/driver/include)

#install LICENSE for petalinux build
install(FILES ${XRT_DKMS_DRIVER_SRC_BASE_DIR}/pcie/driver/linux/xocl/LICENSE DESTINATION ${XRT_DKMS_INSTALL_DIR}/driver/xocl)

=== src/runtime_src/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
#

# Note: Add Windows compilation directives at the END of this file

if( NOT WIN32)

if(${CMAKE_BUILD_TYPE} STREQUAL "Release" AND (NOT XRT_EDGE))
  xrt_add_subdirectory(doc)
endif()

option(XOCL_VERBOSE "Enable xocl verbosity" OFF)
option(XRT_VERBOSE "Enable xrt verbosity" OFF)

if (XOCL_VERBOSE)
  add_compile_options("-DXOCL_VERBOSE")
endif()

if(XRT_VERBOSE)
  add_compile_options("-DXRT_VERBOSE")
endif()

add_compile_options("-fPIC")

if (XRT_ENABLE_WERROR)
  list(APPEND XRT_WARN_OPTS "-Werror")
endif(XRT_ENABLE_WERROR)

if (NOT XRT_EDGE)
  add_compile_options( ${XRT_WARN_OPTS} )
endif()
xrt_add_subdirectory(xdp)

xrt_add_subdirectory(tools/xclbinutil)
xrt_add_subdirectory(xocl)
xrt_add_subdirectory(xrt)

if (XRT_ALVEO)
  # Enable building of ERT firmware for Alveo
  xrt_add_subdirectory(ert)
endif()

# --- Optional HIP bindings ---
if (XRT_ENABLE_HIP)
  xrt_add_subdirectory(hip)
endif(XRT_ENABLE_HIP)

if (NOT XRT_EDGE)
  # Only for host native build.
  # For embedded, headers and libraries are installed in /usr
  # Not requeired setup.sh/.csh
  xrt_add_subdirectory(tools/scripts)
endif()

# Attach to the user's linker flags
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-Bsymbolic")
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")

xrt_add_subdirectory(core)

else()
# = WINDOWS ===================================================================

  # Enable ALL warnings and make them errors if they occur
  if (MSVC)
    # warning level 4 and all warnings are errors
    add_compile_options(/WX /W4)
    if (DEFINED MSVC_PARALLEL_JOBS)
      string(CONCAT MP_OPTION "/MP" ${MSVC_PARALLEL_JOBS})
      add_compile_options(${MP_OPTION})
    endif()
  else()
    # lots of warnings and all warnings as errors
    # add_compile_options(-Wall -Wextra -pedantic -Werror)
    add_compile_options( ${XRT_WARN_OPTS} )
  endif()

  if (XRT_NPU)
    # Used by xdp for include search path
    set(AIERT_DIR ${CMAKE_CURRENT_BINARY_DIR}/aie-rt/driver/src)
    set(XAIENGINE_BUILD_SHARED OFF)
    xrt_add_subdirectory_disable_install_target(aie-rt/driver/src)

    # This enables aiebu submodule use aie-rt binaries built
    # by XRT from above
    set(AIEBU_AIE-RT_BIN_DIR ${AIERT_DIR})
    set(AIEBU_AIE-RT_HEADER_DIR ${AIERT_DIR}/include)
  endif()

  # Build Subdirectories
  xrt_add_subdirectory(xocl)
  xrt_add_subdirectory(xrt)
  xrt_add_subdirectory(tools/xclbinutil)
  xrt_add_subdirectory(xdp)
  xrt_add_subdirectory(tools/scripts)
  xrt_add_subdirectory(core)

  # --- Optional HIP bindings ---
  if (XRT_ENABLE_HIP)
    xrt_add_subdirectory(hip)
  endif(XRT_ENABLE_HIP)
endif()

=== tests/hip/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2024 Advanced Micro Devices, Inc. All rights reserved.

CMAKE_MINIMUM_REQUIRED(VERSION 3.5.0)
PROJECT(HIP_TESTCASES)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED OFF)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(XILINX_XRT $ENV{XILINX_XRT})
set(XRT_CORE_LIBRARY xrt_core)
set(XRT_HIP_LIBRARY xrt_hip)

add_compile_options(-D__HIP_PLATFORM_AMD__)

if (MSVC)
  add_compile_options(/Zc:__cplusplus)
endif()

if (NOT DEFINED ${INSTALL_DIR})
  set(INSTALL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/build/${CMAKE_SYSTEM_NAME}/${CMAKE_BUILD_TYPE}/${MODE}")
endif()

# config file for getting hip headers
include(${CMAKE_CURRENT_SOURCE_DIR}/../../src/runtime_src/hip/hip_config.cmake)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  find_program(CLANG_TIDY "clang-tidy")
  if(NOT CLANG_TIDY)
    message(WARNING "-- clang-tidy not found, cannot enable static analysis")
  else()
    message("-- Enabling clang-tidy")
    set(CMAKE_CXX_CLANG_TIDY "clang-tidy")
  endif()
endif()

include_directories(${HIP_INCLUDE_DIRS} "${CMAKE_CURRENT_SOURCE_DIR}/common" )

add_subdirectory(device)
add_subdirectory(vadd)
add_subdirectory(vadd-stream)

=== tests/message-mgmt/Makefile ===
CC    = g++

xrt_install_path := "/opt/xilinx/xrt"
ifdef XRT_INSTALL_PATH
	xrt_install_path := ${XRT_INSTALL_PATH}
endif

CFLAGS = -DDSA64 -g -std=c++11 mssg.cpp -I../../build/Debug${xrt_install_path}/include
LDFLAGS = -L../../build/Debug${xrt_install_path}/lib -lxrt_core -lpthread -lrt
run:
	@$(CC) $(CFLAGS) -o host.exe $(LDFLAGS)

clean:
	@find . -name '*.log' -delete
	@find . -name '*.exe' -delete
	@find ../ -name '*.log' -delete


%:
	@true

=== tests/xrt/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2022 Xilinx, Inc. All rights reserved.
#
CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0)
PROJECT(XRT_TESTCASES)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED OFF)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(XILINX_XRT $ENV{XILINX_XRT})
set(XRT_CORE_LIBRARY xrt_core)

if (MSVC)
  add_compile_options(/Zc:__cplusplus)
endif()

if (NOT DEFINED ${INSTALL_DIR})
  set(INSTALL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/build/${CMAKE_SYSTEM_NAME}/${CMAKE_BUILD_TYPE}/${MODE}")
endif()

add_subdirectory(00_hello)
add_subdirectory(02_simple)
add_subdirectory(03_loopback)
add_subdirectory(04_swizzle)
add_subdirectory(07_sequence)
add_subdirectory(11_fp_mmult256)
add_subdirectory(13_add_one)
add_subdirectory(56_xclbin)
add_subdirectory(abort)
add_subdirectory(fa_kernel)
add_subdirectory(mailbox)
add_subdirectory(query)
add_subdirectory(enqueue)
add_subdirectory(m2m_arg)
if (NOT WIN32)
  add_subdirectory(102_multiproc_verify)
endif(NOT WIN32)

=== src/python/pybind11/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2020-2021 Xilinx, Inc. All rights reserved.
#

if( NOT WIN32)

# find_package(PythonLibs is depracted as of cmake 3.12.
if (CMAKE_VERSION VERSION_LESS "3.12")
  find_package(PythonLibs 3.4.0 REQUIRED)
  if (PythonLibs_FOUND)
    message("-- Python libs version: ${PYTHONLIBS_VERSION_STRING}")
    message("-- PYTHON_INCLUDE_PATH ${PYTHON_INCLUDE_PATH}")
    string(REPLACE "." ";" PYTHONLIBS_VERSION_LIST ${PYTHONLIBS_VERSION_STRING})
    list(GET PYTHONLIBS_VERSION_LIST 0 PYTHONLIBS_VERSION_MAJOR)
    list(GET PYTHONLIBS_VERSION_LIST 1 PYTHONLIBS_VERSION_MINOR)
  endif(PythonLibs_FOUND)
  set(HAS_PYTHON ${PythonLibs_FOUND})
else()
  if (DEFINED ENV{VIRTUAL_ENV})
    # Virtual environment detected, use its Python
    set(Python3_EXECUTABLE $ENV{VIRTUAL_ENV}/bin/python3)
    message(STATUS "Virtual environment detected, using Python3: ${Python3_EXECUTABLE}")
  else()
    # No virtual environment, use system Python3
    # In alma 8.10 python3.11 comes as a dependency but still pybind11 is installed to default python3.
    set(Python3_EXECUTABLE /usr/bin/python3)
  endif()

  find_package(Python3 COMPONENTS Development Interpreter)
  if (Python3_FOUND)
    message("-- Python libs version: ${Python3_VERSION}")
    message("-- PYTHON_INCLUDE_PATH ${Python3_INCLUDE_DIRS}")
    message("-- Python3_SITEARCH ${Python3_SITEARCH}")
    set(PYTHONLIBS_VERSION_MAJOR ${Python3_VERSION_MAJOR})
    set(PYTHONLIBS_VERSION_MINOR ${Python3_VERSION_MINOR})
  endif(Python3_FOUND)
  set(HAS_PYTHON ${Python3_FOUND})
endif(CMAKE_VERSION VERSION_LESS "3.12")

if (HAS_PYTHON)
  if (${LINUX_FLAVOR} MATCHES "^(ubuntu|debian)")
    SET(PKGDIR "dist-packages")
  elseif (${LINUX_FLAVOR} MATCHES "^(rhel|centos|amzn|fedora|sles|almalinux|rocky)")
    SET(PKGDIR "site-packages")
  endif(${LINUX_FLAVOR} MATCHES "^(ubuntu|debian)")
  find_package(pybind11 2.6.0 REQUIRED PATHS "$ENV{VIRTUAL_ENV}/lib/python${PYTHONLIBS_VERSION_MAJOR}.${PYTHONLIBS_VERSION_MINOR}/${PKGDIR}/pybind11" "/usr/local/lib/python${PYTHONLIBS_VERSION_MAJOR}.${PYTHONLIBS_VERSION_MINOR}/${PKGDIR}/pybind11" "/usr/lib/python${PYTHONLIBS_VERSION_MAJOR}.${PYTHONLIBS_VERSION_MINOR}/${PKGDIR}/pybind11")

endif(HAS_PYTHON)

if (pybind11_FOUND)
  INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})
  pybind11_add_module(pyxrt src/pyxrt.cpp)
  target_link_libraries(pyxrt PRIVATE xrt_coreutil uuid pthread)

  if (CMAKE_INSTALL_PREFIX STREQUAL "/usr"
      OR CMAKE_INSTALL_PREFIX STREQUAL "/usr/local")
    set (XRT_INSTALL_PYTHON_DIR ${Python3_SITEARCH})
  endif()

  install(TARGETS pyxrt
    EXPORT xrt-targets
    LIBRARY DESTINATION ${XRT_INSTALL_PYTHON_DIR} COMPONENT ${XRT_BASE_COMPONENT}
    )

else(pybind11_FOUND)
  message(WARNING "-- pybind11 or python3 libs not found, pybind11 support disabled")
endif(pybind11_FOUND)

else()
# = WINDOWS ===================================================================

find_package(Python3 COMPONENTS Development Interpreter)
if (Python3_FOUND)
  message("-- Python libs version: ${Python3_VERSION}")
  message("-- PYTHON_INCLUDE_PATH ${Python3_INCLUDE_DIRS}")
  set(PYTHONLIBS_VERSION_MAJOR ${Python3_VERSION_MAJOR})
  set(PYTHONLIBS_VERSION_MINOR ${Python3_VERSION_MINOR})
endif(Python3_FOUND)

set(HAS_PYTHON ${Python3_FOUND})

if (HAS_PYTHON)
    execute_process(COMMAND ${Python3_EXECUTABLE} -c "import os, pathlib, pybind11; print(pathlib.Path(os.path.dirname(pybind11.__file__)).as_posix())"
      RESULT_VARIABLE pybind_found
      OUTPUT_VARIABLE PKGDIR
      ERROR_VARIABLE pybind_error
      OUTPUT_STRIP_TRAILING_WHITESPACE
      )

  if(pybind_found EQUAL 0)
    message("-- pybind11 location: ${PKGDIR}")
    find_package(pybind11 2.10.4 REQUIRED PATHS "${PKGDIR}")
  else()
    message(WARNING "-- Failed to import pybind11. Error: ${pybind_error}")
  endif()

endif(HAS_PYTHON)

if (pybind11_FOUND)
  INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})
  pybind11_add_module(pyxrt src/pyxrt.cpp)
  target_link_libraries(pyxrt PRIVATE xrt_coreutil uuid)
  set_target_properties(pyxrt PROPERTIES SUFFIX ".pyd")

  install(TARGETS pyxrt
    EXPORT xrt-targets
    LIBRARY DESTINATION ${XRT_INSTALL_PYTHON_DIR} COMPONENT ${XRT_BASE_COMPONENT}
    )

else(pybind11_FOUND)
  message(WARNING "-- pybind11 or python3 libs not found, pybind11 support disabled")
endif(pybind11_FOUND)

endif()

=== src/runtime_src/core/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
# Copyright (C) 2025 Advanced Micro Devices, Inc. All rights reserved.
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  )

add_subdirectory(include)

if (NOT XRT_EDGE)
  xrt_add_subdirectory(common)
  xrt_add_subdirectory(pcie)
  xrt_add_subdirectory(tools)
else()
  xrt_add_subdirectory(common)
  xrt_add_subdirectory(edge)
  xrt_add_subdirectory(tools)
endif()

=== src/runtime_src/doc/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
#
set(XRT_RUNTIME_SRC_DIR    "${CMAKE_CURRENT_SOURCE_DIR}/..")
set(XRT_DOC_TOC_DIR        "${CMAKE_CURRENT_SOURCE_DIR}/toc")
set(DOC_CORE_DIR           "${CMAKE_CURRENT_BINARY_DIR}/core")
set(DOC_TOC_DIR            "${CMAKE_CURRENT_BINARY_DIR}/toc")

file(GLOB XRT_MGMT_IOCTL_H ${XRT_RUNTIME_SRC_DIR}/core/pcie/driver/linux/include/mgmt-ioctl.h)
file(GLOB XRT_XOCL_IOCTL_H ${XRT_RUNTIME_SRC_DIR}/core/pcie/driver/linux/include/xocl_ioctl.h)
file(GLOB XRT_ZOCL_IOCTL_H ${XRT_RUNTIME_SRC_DIR}/core/edge/include/zynq_ioctl.h)
file(GLOB XRT_BO_H         ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_bo.h)
file(GLOB XRT_DEVICE_H     ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_device.h)
file(GLOB XRT_IP_H         ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/experimental/xrt_ip.h)
file(GLOB XRT_KERNEL_H     ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_kernel.h)
file(GLOB XRT_MAILBOX_H    ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/experimental/xrt_mailbox.h)
file(GLOB XRT_MESSAGE_H    ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/experimental/xrt_message.h)
#file(GLOB XRT_QUEUE_H      ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_queue.h)
file(GLOB XRT_SYSTEM_H     ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/experimental/xrt_system.h)
file(GLOB XRT_UUID_H       ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_uuid.h)
file(GLOB XRT_XCLBIN_H     ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/experimental/xrt_xclbin.h)
file(GLOB XRT_INI_H        ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/experimental/xrt_ini.h)
file(GLOB XRT_ERT_H        ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/detail/ert.h)
file(GLOB XRT_MAILBOX_PROTO_H ${XRT_RUNTIME_SRC_DIR}/core/pcie/driver/linux/include/mailbox_proto.h)
file(GLOB XRT_MAILBOX_C    ${XRT_RUNTIME_SRC_DIR}/core/pcie/driver/linux/xocl/subdev/mailbox.c)

file(MAKE_DIRECTORY ${DOC_CORE_DIR})
file(COPY ${XRT_DOC_TOC_DIR} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

set(KERNELDOC "${CMAKE_BINARY_DIR}/kernel-doc")
set(KERNELDOC_URL "https://git.kernel.org/pub/scm/linux/kernel/git/stable/linux-stable.git/plain/scripts/kernel-doc?h=v4.14.52")

if (NOT EXISTS ${KERNELDOC})
  MESSAGE(STATUS "${KERNELDOC} downloading")
  file(DOWNLOAD ${KERNELDOC_URL} ${KERNELDOC})
  execute_process(COMMAND chmod +x ${KERNELDOC})
endif ()

find_program(KERNELDOC_EXECUTABLE ${KERNELDOC} PATHS ${CMAKE_BINARY_DIR})
find_program(SPHINX_EXECUTABLE sphinx-build)
find_program(DOXYGEN_EXECUTABLE doxygen)

if (NOT DOXYGEN_EXECUTABLE)
  message(WARNING "doxygen not found, XRT C++ documentation is disabled")
  add_custom_target(
    doxygen
    )
else()
  set(XRT_CPP_APIS
    ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_device.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_bo.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_kernel.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/xrt/xrt_uuid.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_ini.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_mailbox.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_message.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_ip.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_system.h
    ${XRT_RUNTIME_SRC_DIR}/core/include/experimental/xrt_xclbin.h
    )
  string(REPLACE ";" " " DOXY_INPUT "${XRT_CPP_APIS}")
  set(DOXYFILE ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
  add_custom_target(
    doxygen
    DEPENDS ${XRT_CPP_APIS}
    COMMAND ${DOXYGEN_EXECUTABLE} -g ${DOXYFILE}
    COMMAND echo "PROJECT_NAME = XRT" >> ${DOXYFILE}
    COMMAND echo "GENERATE_XML = YES" >> ${DOXYFILE}
    COMMAND echo "MACRO_EXPANSION = YES" >> ${DOXYFILE}
    COMMAND echo "EXTRACT_ALL = YES" >> ${DOXYFILE}
    COMMAND echo "SHOW_NAMESPACES = YES" >> ${DOXYFILE}
    COMMAND echo "PREDEFINED = __cplusplus XCL_DRIVER_DLLESPEC=" >> ${DOXYFILE}
    COMMAND echo "EXPAND_AS_DEFINED = XCL_DRIVER_DLLESPEC" >> ${DOXYFILE}
    COMMAND echo "IMAGE_PATH = ${XRT_DOC_TOC_DIR}" >> ${DOXYFILE}
    COMMAND echo "INPUT = ${DOXY_INPUT}" >> ${DOXYFILE}
    COMMAND ${DOXYGEN_EXECUTABLE}
    )
endif(NOT DOXYGEN_EXECUTABLE)

if (NOT KERNELDOC_EXECUTABLE OR NOT SPHINX_EXECUTABLE)
  MESSAGE (WARNING "kernel-doc or Sphinx not found, XRT documentation build disabled")
else ()
  add_custom_command(OUTPUT core/mgmt-ioctl.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_MGMT_IOCTL_H} > core/mgmt-ioctl.rst
    DEPENDS ${XRT_MGMT_IOCTL_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/xocl_ioctl.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XOCL_IOCTL_H} > core/xocl_ioctl.rst
    DEPENDS ${XRT_XOCL_IOCTL_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/zocl_ioctl.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_ZOCL_IOCTL_H} > core/zocl_ioctl.rst
    DEPENDS ${XRT_ZOCL_IOCTL_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_bo.rst
    DEPENDS ${XRT_BO_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_BO_H} > core/xrt_bo.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_device.rst
    DEPENDS ${XRT_DEVICE_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_DEVICE_H} > core/xrt_device.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_ini.rst
    DEPENDS ${XRT_INI_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_INI_H} > core/xrt_ini.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_ip.rst
    DEPENDS ${XRT_IP_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_IP_H} > core/xrt_ip.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_kernel.rst
    DEPENDS ${XRT_KERNEL_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_KERNEL_H} > core/xrt_kernel.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_message.rst
    DEPENDS ${XRT_MESSAGE_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_MESSAGE_H} > core/xrt_message.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_system.rst
    DEPENDS ${XRT_SYSTEM_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_SYSTEM_H} > core/xrt_system.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_uuid.rst
    DEPENDS ${XRT_UUID_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_UUID_H} > core/xrt_uuid.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/xrt_xclbin.rst
    DEPENDS ${XRT_XCLBIN_H}
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_XCLBIN_H} > core/xrt_xclbin.rst
    VERBATIM
    )

  add_custom_command(OUTPUT core/ert.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_ERT_H} > core/ert.rst
    DEPENDS ${XRT_ERT_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/mailbox_proto.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_MAILBOX_PROTO_H} > core/mailbox_proto.rst
    DEPENDS ${XRT_MAILBOX_PROTO_H}
    VERBATIM
    )

  add_custom_command(OUTPUT core/mailbox.rst
    COMMAND ${KERNELDOC_EXECUTABLE} -rst ${XRT_MAILBOX_C} > core/mailbox.rst
    DEPENDS ${XRT_MAILBOX_C}
    VERBATIM
    )


  add_custom_target(
    xrt_docs
    DEPENDS
    doxygen
    core/mgmt-ioctl.rst
    core/xocl_ioctl.rst
    core/zocl_ioctl.rst
    core/xrt_bo.rst
    core/xrt_device.rst
    core/xrt_ini.rst
    core/xrt_ip.rst
    core/xrt_kernel.rst
    core/xrt_message.rst
    core/xrt_system.rst
    core/xrt_uuid.rst
    core/xrt_xclbin.rst
    core/ert.rst
    core/mailbox_proto.rst
    core/mailbox.rst
    COMMENT "Generating documentation with Sphinx"
    COMMAND ${CMAKE_COMMAND} -E make_directory  html
    COMMAND rm -rf ${DOC_TOC_DIR}/*
    COMMAND cp -rf ${XRT_DOC_TOC_DIR}/* ${DOC_TOC_DIR}
    COMMAND ${SPHINX_EXECUTABLE} -a ${DOC_TOC_DIR} html
    )
endif ()

# Don't forget to add a rst file under toc/ for html generation

=== src/runtime_src/ert/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2019-2021 Xilinx, Inc. All rights reserved.
# Copyright (C) 2025 Advanced Micro Devices, Inc. All rights reserved.

set(ERT_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/share/fw")
set(ERT_INSTALL_FIRMWARE_PREFIX "/lib/firmware/xilinx")

if ((EXISTS $ENV{XILINX_VITIS}/gnu/microblaze) AND (NOT XRT_EDGE) AND (${CMAKE_HOST_SYSTEM_PROCESSOR} STREQUAL "x86_64"))

message("-- MicroBlaze toolchain found, preparing ERT build")
set(ERT_BUILD_ALL "yes")
add_subdirectory(scheduler)

add_custom_target(ert ALL
 DEPENDS scheduler
 )

elseif (DEFINED ENV{XRT_FIRMWARE_DIR})

file(GLOB ERTFW_FILES
  "$ENV{XRT_FIRMWARE_DIR}/sched*.bin"
  )

message("-- ERT firmare files copied from ${ERTFW_FILES}")

install(FILES
  ${ERTFW_FILES}
  DESTINATION ${ERT_INSTALL_PREFIX}
  )

install(FILES
  ${ERTFW_FILES}
  DESTINATION ${ERT_INSTALL_FIRMWARE_PREFIX}
  )

set(ERT_BUILD_ALL "no")
add_subdirectory(scheduler)

else()

message(WARNING
"****************************************************************\n\
No firmware files built or copied, resulting XRT package will be missing ERT \
scheduler firmware.  Use build.sh -ertfw <dir> to specify path to a directory \
with firmware to copy during XRT build.\n
****************************************************************")
set(ERT_BUILD_ALL "no")
add_subdirectory(scheduler)

endif()

=== src/runtime_src/hip/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# Copyright (C) 2023 Advanced Micro Devices, Inc. All rights reserved.

# config file for getting hip headers
include(hip_config.cmake)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  find_program(CLANG_TIDY "clang-tidy")
  if(NOT CLANG_TIDY)
    message(WARNING "-- clang-tidy not found, cannot enable static analysis")
  else()
    message("-- Enabling clang-tidy")
    set(CMAKE_CXX_CLANG_TIDY "clang-tidy")
  endif()
endif()

add_subdirectory(core)
add_subdirectory(api)

if (WIN32)
  add_library(xrt_hip SHARED
    $<TARGET_OBJECTS:hip_core_library_objects>
    $<TARGET_OBJECTS:hip_api_library_objects>
    xrt_hip.def
  )
else()
  add_library(xrt_hip SHARED
    $<TARGET_OBJECTS:hip_core_library_objects>
    $<TARGET_OBJECTS:hip_api_library_objects>
  )
endif()

target_include_directories(xrt_hip
  PUBLIC
  $<BUILD_INTERFACE:${XRT_SOURCE_DIR}/runtime_src>
  $<INSTALL_INTERFACE:${XRT_INSTALL_INCLUDE_DIR}>
)

target_link_libraries(xrt_hip
  PRIVATE
  xrt_coreutil
)

set_target_properties(xrt_hip PROPERTIES
  VERSION ${XRT_VERSION_STRING}
  SOVERSION ${XRT_SOVERSION}
)

install(TARGETS xrt_hip
  EXPORT xrt-targets
  RUNTIME DESTINATION ${XRT_INSTALL_BIN_DIR} COMPONENT ${XRT_BASE_COMPONENT}
  LIBRARY DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_COMPONENT} NAMELINK_COMPONENT ${XRT_BASE_DEV_COMPONENT}
  ARCHIVE DESTINATION ${XRT_INSTALL_LIB_DIR} COMPONENT ${XRT_BASE_DEV_COMPONENT}
)

# Release headers
install (FILES hip_xrt.h
  DESTINATION ${XRT_INSTALL_INCLUDE_DIR}/hip
  COMPONENT ${XRT_BASE_DEV_COMPONENT}
)

if (WIN32)
  # Windows: install entire hip include directory
  install (DIRECTORY ${HIP_INCLUDE_DIR}/hip
    DESTINATION ${XRT_INSTALL_INCLUDE_DIR}
    COMPONENT ${XRT_BASE_DEV_COMPONENT}
  )
endif()

=== debian/control ===
Source: xrt
Section: libs
Priority: optional
Maintainer: Debian Xilinx Package Maintainers <team+pkg-xilinx@tracker.debian.org>
Uploaders: Punit Agrawal <punit@debian.org>,
	   Nobuhiro Iwamatsu <iwamatsu@debian.org>,
	   Mario Limonciello <superm1@debian.org>,
Build-Depends: cmake,
	debhelper-compat (= 13),
	bash-completion,
	doxygen [amd64],
	git,
	help2man,
	libboost-filesystem-dev,
	libboost-program-options-dev,
	libboost-system-dev,
	libdrm-dev,
	libncurses-dev,
	libprotobuf-dev,
	libssl-dev,
	libudev-dev,
	libyaml-dev,
	lsb-release [amd64],
	ocl-icd-opencl-dev,
	ocl-icd-dev,
	pkgconf,
	protobuf-compiler,
	pybind11-dev,
	rapidjson-dev,
	systemtap-sdt-dev,
	uuid-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.xilinx.com/products/design-tools/vitis/xrt.html
Vcs-Git: https://salsa.debian.org/xilinx-packages-team/xrt.git
Vcs-Browser: https://salsa.debian.org/xilinx-packages-team/xrt

Package: libxrt2
Architecture: arm64 amd64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libxrt1 (<< ${binary:Version})
Conflicts: libxrt1
Replaces: libxrt1
Description: Xilinx Runtime (XRT) - runtime libraries
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the runtime environment for xrt.

Package: python3-xrt
Architecture: arm64 amd64
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends}, python3, libxrt2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - Python bindings
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides Python bindings for XRT.

Package: libxrt-dev
Architecture: arm64 amd64
Section: libdevel
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, libxrt2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - development files
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package provides the development environment for xrt.

Package: libxrt-utils
Architecture: arm64 amd64
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}, python3, libxrt2 (= ${binary:Version})
Description: Xilinx Runtime (XRT) - runtime -- utilities
 Xilinx Runtime library (XRT) is an open-source easy to
 use software stack that facilitates management and usage of
 field-programmable gate array (FPGA) / Adaptive Compute Acceleration
 Platform (ACAP) devices. Users use familiar programming languages
 like C/C++ or Python to write host code which uses XRT to interact
 with FPGA/ACAP device. XRT exports well defined set of software APIs
 that work across PCIe based datacenter platforms and ZYNQ UltraScale+
 MPSoC/Versal ACAP based embedded platforms. XRT is a combination of
 userspace and kernel driver components.
 .
 This package contains a utilities from the xrt project.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

BUILDDIR := obj-$(shell dpkg-architecture -q DEB_HOST_GNU_TYPE)

CONFIGURE_ARGS = -DCMAKE_BUILD_TYPE=Release -DXRT_NPU=1 -DXRT_UPSTREAM_DEBIAN=1

%:
	dh $@ --with bash-completion

override_dh_auto_configure:
	dh_auto_configure --sourcedir=src -- $(CONFIGURE_ARGS)

override_dh_auto_install:
	dh_auto_install
	# man pages
	mkdir -p debian/libxrt-utils/usr/share/man/man1
	# doesn't work for xrt-runner xrt-smi xrt-tracer
	for bin in xclbinutil xrt-replay; do \
	  LD_LIBRARY_PATH=debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE) help2man debian/tmp/usr/bin/$$bin > debian/libxrt-utils/usr/share/man/man1/$$bin.1; \
	done

override_dh_auto_test:
	make -C $(BUILDDIR) install DESTDIR=`pwd`/$(BUILDDIR) # xrt-smi and xbmgmt tests require install
	dh_auto_test
